//+------------------------------------------------------------------+
//|                                             i-SpectrAnalysis.mq5 |
//|                                           Copyright  2006, klot |
//|                                                     klot@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, klot"
#property link      "klot@mail.ru"
//---   
#property version   "1.00"
//---     
#property indicator_chart_window 
//---   
#property indicator_buffers 1 
//---     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//---     
#property indicator_type1   DRAW_LINE
//---       Red 
#property indicator_color1 clrRed
//---   -  
#property indicator_style1  STYLE_SOLID
//---     2
#property indicator_width1  2
//---   
#property indicator_label1  "i_SpecktrAnalis"
//+-----------------------------------+
//|   dt_FFT.mqh    |
//+-----------------------------------+
#include <dt_FFT.mqh> 
//+-----------------------------------+
//|         |
//+-----------------------------------+
input uint N = 7;   //  
input uint SS = 20; //  
input int Shift=0;  //      
//+-----------------------------------+
//---   ,   
//---      
double IndBuffer[];
//---
int M,tnn1,ss;
//---
double aa[];
//---      
int min_rates_total;
//+------------------------------------------------------------------+   
//| i-SpectrAnalysis indicator initialization function               | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//---     
   tnn1=int(MathPow(2,N));
   M=ArrayResize(aa,tnn1+1);
   ss=int(MathMin(SS,M));
   min_rates_total=int(M);
//---      
   SetIndexBuffer(0,IndBuffer,INDICATOR_DATA);
//---    1  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//---      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,"i-SpecktrAnalis");
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//---  
  }
//+------------------------------------------------------------------+ 
//| i-SpecktrAnalis iteration function                               | 
//+------------------------------------------------------------------+ 
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const int begin,          //     
                const double &price[])    //     
  {
//---       
   if(rates_total<min_rates_total+begin) return(0);
//---
   for(int bbb=rates_total-1; bbb>=prev_calculated && !IsStopped(); bbb--) IndBuffer[rates_total-1-bbb]=0.0;
//---
   int end=M-1;
   for(int iii=M-1; iii>=0 && !IsStopped(); iii--) aa[iii]=price[rates_total-1-iii];
   fastcosinetransform(aa,tnn1,false);
   for(int kkk=0; kkk<=end && !IsStopped(); kkk++) if(kkk>=ss) aa[kkk]=0.0;
   fastcosinetransform(aa,tnn1,true);
   for(int rrr=0; rrr<=end && !IsStopped(); rrr++) IndBuffer[rates_total-1-rrr]=aa[rrr];
//---
   return(rates_total);
  }
//+------------------------------------------------------------------+
